<?php
require('./tools/formtools.php');
require('./tools/seqtools.php');// include sequence functions, parsing etc.

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];
$pos_start=(int)$_POST['pos_start'];
$pos_end=(int)$_POST['pos_end'];

function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}

function crop_alignment($sequences, $s,$e) {
  $r['text'].="";
  $r['html'].="<PRE>";
  foreach ($sequences as $seq) {
    $r['text'] .= ">".$seq[0]."\n";
    $r['text'] .= substr($seq[1],$s, $e)."\n\n";

    $r['html'] .= "<span style='background-color: #ffaaaa'>".substr($seq[1],0,$s)."</span>";
    $r['html'] .= "<span style='background-color: #aaddaa'>".substr($seq[1], $s, $e)."</SPAN>";
    $r['html'] .= "<span style='background-color: #ffaaaa'>".substr($seq[1], $e, strlen($seq[1]) )."</SPAN>\n";
  }

  $r['text'].="";
  $r['html'].="</PRE>";


  $r['textlabel']="Cropped alignment in fasta format";
  $r['htmllabel']="Alignment blocks (red=cropped, green=kept) ";

  $r['filename']="cropped_alignment.fasta";
  $r['filelabel']="Save cropped alignment to disk ";
  return $r;
}

if ($submit) {
  $r= parse_sequences($inputseqs);
  if ($r[0]=="0") {
    $al=crop_alignment($r[1], $pos_start, $pos_end);
  } else {
    $error = $r[1];
  }
  unset($r);
}
//
// BEGIN HTML OUTPUT!
//
show_page_header("Crop alignment to specified positions", "<a href='#formtools.results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
?>
<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/alignment_trimmer.fa") 
?>
<P>
<!-- Settings fieldset -->
<fieldset>
<legend>Settings</legend>

<P>
<label>Start position (0 is first base)</label>
<input type="text" name ="pos_start" size=10 value="<?php if($submit) {echo $pos_start;} if ($submit_example) { echo '5';} ?>" >
</p>
<P>
<label>End position (this position is not included)</label>
<input type="text" name ="pos_end" size=10 value="<?php if($submit) {echo $pos_end;} if ($submit_example) { echo '15';} ?>" >
</p>

<?php
show_submit_buttons("Crop alignment");
?>
</fieldset>
</form>

<?php
if ($submit and !$error) {
  $b[] = get_save_button($al, 'r1'); # result 1
  print get_save_form($b, "Save cropped alignment");
  print get_results_from_buttons($b);
  print "<h1>Alignment</h1>";
  print "<pre>".$al["text"]."</pre>";
}

show_page_footer();
?>
