<?php
require('./tools/seqtools.php');// include sequence functions, parsing etc.
require('./tools/formtools.php');
require('./tools/reporttools.php');

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];
$filename=$_POST['filename'];

function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}

function get_paml($haplotypes, $fn="data.paml") {
  $numberofhaplotypes=count($haplotypes);
  $len=strlen($haplotypes[0][1]); // getting length of first sequence
  $gc="-";
  $mrbayes= " $numberofhaplotypes $len\n";
 foreach ($haplotypes as $current){
   $header=$current[0];
   $mrbayes .= "$header"."  ".$current[1]."\n";
 }

 $mrbayes .= "\n";
 
  $r['text'] = $mrbayes;
  $r['textlabel']="PAML data file";

  $r['html'] = "<h3>Output below is only shown for information: use the 'save to disk' button</h3><PRE>$mrbayes</PRE>\n";
  $r['htmllabel']="PAML data file";

  $r['filename']= "$fn";
  $r['filelabel']="Save PAML data file";
 return $r;
}


if ($submit) {
  $r= parse_sequences($inputseqs);
  if ($r[0]=="0") {
    $sequences=$r[1];
    $mb= get_paml($sequences, $filename);
  } else {
    $error = $r[1];
    $r='';
  }
  unset($r);
}
//
// BEGIN HTML OUTPUT!
//
show_page_header("Fasta to PAML converter", "<a href='#results'>Conversion finished, results are at bottom (or click here)</a>", $submit, $error);
?>
<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/fasta2paml.fa") 
?>
<P>
<!-- Settings fieldset -->
<fieldset>
<legend>Settings</legend>
<P>
<label>(Optional) custom output filename</label> <input type="text" name ="filename" size=15 value="<?php if($filename) {echo $filename; } else {echo 'paml_phylip.phy';}?>"/>
</p>
<?php
show_submit_buttons("Do formatting");
?>
</fieldset>
</form>

<!-- RESULTS SECTION  -->

<?php
   if ($error) {
     print "<h1><font color ='#AA0000'><br> $error</font></h1>\n";
   }
 
  if ($submit and !$error) {
    print "<a name='results'>";
    $b[] = get_save_button($mb, 'r1');
    print get_save_form($b, "Save PAML input file (phylip format with double spaces and sequential format)");
    print get_results_from_buttons($b);
}

//
// END HTML OUTPUT
//

?>
<?php
show_page_footer();
?>
