<?php
require('./tools/seqtools.php');// include sequence functions, parsing etc.
require('./tools/formtools.php');
require('./tools/reporttools.php');

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];

function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}

function join_sequences($seqs) {
  for ($i=1; $i<count($seqs); $i++) {// all sequences
    $seqs[0][1] .= $seqs[$i][1];
  }
  $s[]=$seqs[0];
  return array(0,$s); // return new sequence
}

function get_seq_report($seqs) {
  $r['text'].= sequences2fasta($seqs,60);
  $r['html'].= "<PRE>".$r['text']."</PRE>\n";
  $r['textlabel']="Sequence in fasta format";
  $r['htmllabel']="Sequence in fasta format";
  $r['filename']="sequence.fasta";
  $r['filelabel']="Save sequences";
  return $r;
}

if ($submit) {
  $r= parse_sequences($inputseqs);
  if ($r[0]=="0") {
    $sequences=$r[1];
    $r= join_sequences($sequences);
    $s1=get_seq_report($r[1]);
    $r='';
  } else {
    $error = $r[1];
    $r='';
  }
}
//
// BEGIN HTML OUTPUT!
//
show_page_header("Fasta dataset joiner", "<a href='#formtools.results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
?>

<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/fasta_joiner.fa") 
?>
<P>
<!-- Settings fieldset -->

<fieldset>
<legend>Settings</legend>
<P>
<?php
show_submit_buttons ($mm="Join sequences")
?>
</fieldset>

</form>

<!-- RESULTS SECTION  -->

<?php
   if ($error) {
     print "<h1><font color ='#AA0000'><br> $error</font></h1>\n";
   }
 
  if ($submit and !$error) {
    print "<a name='formtools.results'>";

    $b[] = get_save_button($s1, 'r1');
    print get_save_form($b, "Save datasets");
    print get_results_from_buttons($b);

}

//
// END HTML OUTPUT
//
?>
<?php
show_page_footer();
?>
